unit View.OrderEntryCuttingDie;

interface

uses
  System.SysUtils, System.Generics.Collections, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.Menus, WEBLib.ExtCtrls, WEBLib.StdCtrls,
  WEBLib.JSON, Auth.Service, XData.Web.Client, WebLib.Storage,
  ConnectionModule, App.Types, Vcl.StdCtrls, Vcl.Controls, WEBLib.DBCtrls,
  Data.DB, XData.Web.JsonDataset, XData.Web.Dataset, WEBLib.DB;

type
  TFOrderEntryCuttingDie = class(TWebForm)
    WebDataSource1: TWebDataSource;
    XDataWebDataSet1: TXDataWebDataSet;
    XDataWebDataSet1ORDER_ID: TIntegerField;
    XDataWebDataSet1COMPANY_ID: TIntegerField;
    XDataWebDataSet1USER_ID: TIntegerField;
    XDataWebDataSet1ORDER_DATE: TDateField;
    XDataWebDataSet1START_DATE: TDateField;
    XDataWebDataSet1END_DATE: TDateField;
    XDataWebDataSet1ORDER_STATUS: TStringField;
    XDataWebDataSet1SCHED_JSON: TStringField;
    XDataWebDataSet1NAME: TStringField;
    XDataWebDataSet1SHORT_NAME: TStringField;
    XDataWebDataSet1staff_fields_ship_via: TStringField;
    XDataWebDataSet1staff_fields_price: TStringField;
    XDataWebDataSet1staff_fields_invoice_to: TStringField;
    XDataWebDataSet1staff_fields_invoice_attention: TStringField;
    XDataWebDataSet1staff_fields_ship_to: TStringField;
    XDataWebDataSet1staff_fields_ship_attention: TStringField;
    XDataWebDataSet1staff_fields_po_number: TStringField;
    XDataWebDataSet1staff_fields_job_name: TStringField;
    XDataWebDataSet1plates_job_number: TStringField;
    XDataWebDataSet1supplied_by_customer_b_w_copy: TBooleanField;
    XDataWebDataSet1supplied_by_customer_dimension: TStringField;
    XDataWebDataSet1supplied_by_customer_e_mail: TStringField;
    XDataWebDataSet1supplied_by_customer_ftp: TStringField;
    XDataWebDataSet1supplied_by_customer_other: TStringField;
    XDataWebDataSet1supplied_by_customer_existing_: TStringField;
    XDataWebDataSet1supplied_by_customer_ref_art_p: TStringField;
    XDataWebDataSet1supplied_by_customer_ref_art_a: TStringField;
    XDataWebDataSet1cut_die_cutdier: TStringField;
    XDataWebDataSet1cut_die_cutdieb: TStringField;
    XDataWebDataSet1cut_die_cutdief: TStringField;
    XDataWebDataSet1cut_die_cutdierkr: TStringField;
    XDataWebDataSet1cut_die_cutdiefkr: TStringField;
    XDataWebDataSet1cut_die_cad_file: TStringField;
    XDataWebDataSet1cut_die_attached: TStringField;
    XDataWebDataSet1cut_die_boxpol250: TStringField;
    XDataWebDataSet1cut_die_boxpol155: TStringField;
    XDataWebDataSet1cut_die_boxpol125: TStringField;
    XDataWebDataSet1cut_die_brub: TStringField;
    XDataWebDataSet1proofing_fax: TStringField;
    XDataWebDataSet1proofing_fax_attn: TStringField;
    XDataWebDataSet1proofing_e_mail: TStringField;
    XDataWebDataSet1proofing_ship_to: TStringField;
    XDataWebDataSet1proofing_other: TStringField;
    XDataWebDataSet1proofing_changes_required: TStringField;
    XDataWebDataSet1proofing_changes_date: TDateField;
    XDataWebDataSet1layout_rsc_l: TStringField;
    XDataWebDataSet1layout_rcs_w: TStringField;
    XDataWebDataSet1layout_rcs_d: TStringField;
    XDataWebDataSet1layout_die_cut_no: TStringField;
    XDataWebDataSet1layout_accross_no: TStringField;
    XDataWebDataSet1layout_around_no: TStringField;
    XDataWebDataSet1layout_cad_file: TStringField;
    XDataWebDataSet1mounting_standard_setup: TStringField;
    XDataWebDataSet1mounting_custom_backing: TStringField;
    XDataWebDataSet1mounting_custom_adhesive: TStringField;
    XDataWebDataSet1colors_cylinder_size: TStringField;
    XDataWebDataSet1colors_cross_hairs: TStringField;
    XDataWebDataSet1colors_machine_ident: TStringField;
    XDataWebDataSet1colors_clemson: TStringField;
    XDataWebDataSet1plates_thickness: TStringField;
    XDataWebDataSet1plates_plate_material: TStringField;
    XDataWebDataSet1general_special_instructions: TStringField;
    XDataWebDataSet1colors_colors: TStringField;
    XDataWebDataSet1staff_fields_quickbooks_item: TStringField;
    XDataWebDataSet1staff_fields_quantity: TStringField;
    XDataWebDataSet1layout_rsc_style: TStringField;
    XDataWebDataSet1staff_fields_art_location: TStringField;
    XDataWebDataSet1supplied_by_customer_color_copy: TBooleanField;
    XDataWebDataSet1supplied_by_customer_plates: TBooleanField;
    XDataWebDataSet1supplied_by_customer_sample_ca: TBooleanField;
    XDataWebDataSet1supplied_by_customer_disk_or_cd: TBooleanField;
    XDataWebDataSet1mounting_loose: TStringField;
    XDataWebDataSet1mounting_sticky_bak: TBooleanField;
    XDataWebDataSet1mounting_full_mount: TBooleanField;
    XDataWebDataSet1mounting_strip_mount: TStringField;
    XDataWebDataSet1layout_excalibur_die: TBooleanField;
    XDataWebDataSet1proofing_full_size_panel: TBooleanField;
    XDataWebDataSet1proofing_print_card: TBooleanField;
    XDataWebDataSet1proofing_wide_format: TBooleanField;
    XDataWebDataSet1proofing_pdf_file: TBooleanField;
    XDataWebDataSet1proofing_art_approved_as_is: TBooleanField;
    XDataWebDataSet1proofing_e_mail_attn: TStringField;
    XDataWebDataSet1proofing_approved_date: TStringField;
    XDataWebDataSet1staff_fields_order_date: TStringField;
    XDataWebDataSet1staff_fields_proof_date: TStringField;
    XDataWebDataSet1staff_fields_ship_date: TStringField;
    XDataWebDataSet1staff_fields_art_due: TStringField;
    XDataWebDataSet1staff_fields_plate_due: TStringField;
    XDataWebDataSet1staff_fields_mount_due: TStringField;
    XDataWebDataSet1ADDRESS_LIST: TStringField;
    XDataWebDataSet1supplied_by_customer_order_date: TStringField;
    XDataWebClient1: TXDataWebClient;
    tmrScrollTop: TWebTimer;
    WebLabel2: TWebLabel;
    edtCompanyAccountName: TWebDBEdit;
    edtInQuickBooks: TWebDBEdit;
    WebLabel1: TWebLabel;
    dtpOrderDate: TWebDateTimePicker;
    dtpProofDate: TWebDateTimePicker;
    dtpShipDate: TWebDateTimePicker;
    edtShipVia: TWebDBEdit;
    edtQuantity: TWebDBEdit;
    edtPrice: TWebDBEdit;
    edtInvoiceTo: TWebDBEdit;
    wdbcbShipTo: TWebDBComboBox;
    edtPONumber: TWebDBEdit;
    edtJobName: TWebDBEdit;
    edtQuickBooksItem: TWebDBEdit;
    wdsShipTo: TWebDataSource;
    xdwdsShipTo: TXDataWebDataSet;
    xdwdsShipToADDRESS: TStringField;
    WebLabel9: TWebLabel;
    edtSpecialInstructions: TWebDBEdit;
    btnConfirm: TWebButton;
    btnCancel: TWebButton;
    pnlMessage: TWebPanel;
    lblMessage: TWebLabel;
    btnCloseNotification: TWebButton;
    edtCompanyName: TWebDBEdit;
    procedure btnConfirmClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
     procedure WebFormCreate(Sender: TObject);
    procedure HideNotification();
    procedure ShowNotification(Notification: string);
    procedure WebFormShow(Sender: TObject);
    [async] procedure GetCuttingDieOrder(Order_ID: string);
    [async] procedure GetCustomer(customerID: string);
    procedure tmrScrollTopTimer(Sender: TObject);
    [async] procedure AddCuttingDieOrder(orderJSON: TJSONObject);
  private
    FAgencyCode: string;
    FCurrentReportType: string;
    FSelectProc: TSelectProc;
    orderID: string;
    customerID: string;
    mode: string;
  public
    class function CreateForm(AElementID, orderInfo, customerInfo, mode: string): TWebForm;
  end;

var
  FOrderEntryCuttingDie: TFOrderEntryCuttingDie;

implementation

{$R *.dfm}

uses
  View.Home, View.Main;

procedure TFOrderEntryCuttingDie.btnConfirmClick(Sender: TObject);
// Converts all the information on the page into a JSON to then send to the server
var
  I, J: integer;
  orderJSON: TJSONObject;
  fieldNames: TStringList;
  itemList: TJSNodeList;
  header, value: string;
  Field: TField;
  Response: TXDataClientResponse;
begin
  orderJSON := TJSONObject.Create;
  XDataWebDataSet1.Edit;

  //Convert all dates to strings because I was having less issues with that data type.
  XDataWebDataSet1staff_fields_proof_date.Value := DateTimeToStr(dtpProofDate.Date);
  XDataWebDataSet1staff_fields_ship_date.Value := DateTimeToStr(dtpShipDate.Date);
  XDataWebDataSet1staff_fields_order_date.Value := DateTimeToStr(dtpOrderDate.Date);

  XDataWebDataSet1.Post;
  XDataWebDataSet1.First;
  while not XDataWebDataSet1.Eof do
  begin
    for Field in XDataWebDataSet1.Fields do
    begin
      if Field is TStringField then
      begin
        if Field.AsString = '' then
          orderJSON.AddPair(Field.FieldName, '')
        else
          orderJSON.AddPair(Field.FieldName, Field.AsString);  // Add all other fields
      end
      else if Field is TBooleanField then
      begin
        if Field.AsBoolean then
          orderJSON.AddPair(Field.FieldName, 'T')
        else
          orderJSON.AddPair(Field.FieldName, '');
      end;
    end;
    XDataWebDataSet1.Next;
  end;
  orderJSON.AddPair('COMPANY_ID', customerID);
  orderJSON.AddPair('USER_ID', '1011');
  orderJSON.AddPair('mode', mode);
  if mode = 'EDIT' then
    orderJSON.AddPair('ORDER_ID', orderID);
  AddCuttingDieOrder(orderJSON);
  FViewMain.ViewOrders('Success');
end;

procedure TFOrderEntryCuttingDie.AddCuttingDieOrder(orderJSON: TJSONObject);
// sends the order JSON object to the server
var
Response: TXDataClientResponse;
begin
  Response := await(XDataWebClient1.RawInvokeAsync('ILookupService.AddCuttingDieOrder',
              [orderJSON.ToString]));
end;

class function TFOrderEntryCuttingDie.CreateForm(AElementID, orderInfo, customerInfo, mode: string): TWebForm;
var
  localMode: string;
begin
  localMode := mode;
  Application.CreateForm(TFOrderEntryCuttingDie, AElementID, Result,
    procedure(AForm: TObject)
    begin
      with TFOrderEntryCuttingDie(AForm) do
      begin
        HideNotification;
        TFOrderEntryCuttingDie(AForm).customerID := customerInfo;
        TFOrderEntryCuttingDie(AForm).orderID := orderInfo;
        TFOrderEntryCuttingDie(AForm).mode := localMode;
      end;
    end
  );

end;

procedure TFOrderEntryCuttingDie.btnCancelClick(Sender: TObject);
begin
  FViewMain.ViewOrders('');
end;

procedure TFOrderEntryCuttingDie.WebFormCreate(Sender: TObject);
begin
   if not DMConnection.ApiConnection.Connected then
   begin
    DMConnection.ApiConnection.OpenAsync;
    console.log('report requirements connection open')
   end;
end;

procedure TFOrderEntryCuttingDie.getCuttingDieOrder(Order_ID: string);
// retrieves an order from the server then loads the info into the page
var
  xdcResponse: TXDataClientResponse;
  orderList : TJSObject;
  i: integer;
  data: TJSArray;
  order: TJSObject;
begin
  xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetOrder',
        [Order_ID]));
  order :=  TJSObject(xdcResponse.Result);
  data := TJSArray(order['data']);
  XDataWebDataSet1.Close;
  XDataWebDataSet1.SetJsonData(order);
  XDataWebDataSet1.Open;

  // Check boxes and dates need to be manually set

  if not (XDataWebDataSet1staff_fields_order_date.AsString = '') then
    dtpOrderDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_order_date.Value)
  else
    dtpOrderDate.Date := 0;
  if not (XDataWebDataSet1staff_fields_proof_date.AsString = '') then
    dtpProofDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_proof_date.AsString)
  else
    dtpProofDate.Date := 0;
  if not (XDataWebDataSet1staff_fields_ship_date.AsString = '') then
    dtpShipDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_ship_date.AsString)
  else
    dtpShipDate.Date := 0;

  console.log(mode);
  console.log(XDataWebDataSet1COMPANY_ID.AsString);
  if mode = 'EDIT' then
    CustomerID := XDataWebDataSet1COMPANY_ID.AsString;
  console.log(CustomerID);

end;

procedure TFOrderEntryCuttingDie.getCustomer(customerID: string);
// gets a customer from the database then loads the appropiate fields
var
  xdcResponse: TXDataClientResponse;
  customer : TJSObject;
  address: string;
begin

  xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetCustomer',
        [customerID]));
  customer :=  TJSObject(xdcResponse.Result);
  console.log(customer);
  XDataWebDataSet1.Close;
  XDataWebDataSet1.SetJsonData(customer);
  XDataWebDataSet1.Open;
  console.log(XDataWebDataSet1NAME.AsString);

  xdwdsShipTo.Close;
  xdwdsShipTo.SetJSONData(customer['ADDRESS_LIST']);
  xdwdsShipTo.Open;

end;

procedure TFOrderEntryCuttingDie.WebFormShow(Sender: TObject);
begin
  if mode <> 'ADD' then
    getCuttingDieOrder(orderID)
  else
    getCustomer(customerID);
  HideNotification();
end;

procedure TFOrderEntryCuttingDie.HideNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFOrderEntryCuttingDie.ShowNotification(Notification: string);
begin
  if Notification <> '' then
  begin
    lblMessage.Caption := Notification;
    pnlMessage.ElementHandle.hidden := False;
  end;
end;


procedure TFOrderEntryCuttingDie.tmrScrollTopTimer(Sender: TObject);
begin
  tmrScrollTop.Enabled := False;
  window.scrollTo(0, 0);
end;

initialization
  RegisterClass(TFOrderEntryCuttingDie);

end.